﻿using System;
using System.Linq.Expressions;
using System.Web.Mvc;

namespace HttpContextUnitTestSample.DemoStuff
{
    public class ViewModelValidationState : IValidationState
    {

        public ViewModelValidationState(ModelStateDictionary modelState)
        {
            ModelState = modelState;
        }

        private readonly ModelStateDictionary ModelState;

        public string this[string key]
        {
            get { throw new NotImplementedException(); }
        }

        public void AddError<T>(Expression<Func<T, object>> property, string errorMessage)
        {
            ModelState.AddModelError(GetKey(property), errorMessage);
        }

        public void AddError(string key, string errorMessage)
        {
            ModelState.AddModelError(key, errorMessage);
        }

        public bool ContainsKey<T>(Expression<Func<T, object>> property)
        {
            return ModelState.ContainsKey(GetKey(property));
        }

        public bool ContainsKey(string key)
        {
            return ModelState.ContainsKey(key);
        }

        public bool IsValid
        {
            get { return ModelState.IsValid; }
        }

        private static string GetKey<T>(Expression<Func<T, object>> property)
        {
            if (property.Body is UnaryExpression)
                return ((UnaryExpression)property.Body).Operand.ToString().Split('.')[1];
            return ((MemberExpression)property.Body).Member.Name;
        }

    }
}